القائمة الرئيسية

الصفحات

C++ Exception Handling

 An exception is a problem that arises during the execution of a program. A C++ exception is a response to an exceptional circumstance that arises while a program is running, such as an attempt to divide by zero.

Exceptions provide a way to transfer control from one part of a program to another. C++ exception handling is built upon three keywords: try, catch, and throw.

  • throw − A program throws an exception when a problem shows up. This is done using a throw keyword.

  • catch − A program catches an exception with an exception handler at the place in a program where you want to handle the problem. The catch keyword indicates the catching of an exception.

  • try − A try block identifies a block of code for which particular exceptions will be activated. It's followed by one or more catch blocks.

Assuming a block will raise an exception, a method catches an exception using a combination of the try and catch keywords. A try/catch block is placed around the code that might generate an exception. Code within a try/catch block is referred to as protected code, and the syntax for using try/catch as follows −

الاستثناء هو المشكلة التي تنشأ أثناء تنفيذ البرنامج. استثناء C هو استجابة لظروف استثنائية تنشأ أثناء تشغيل أحد البرامج ، مثل محاولة القسمة على صفر. توفر الاستثناءات طريقة لنقل التحكم من جزء من برنامج إلى آخر. تم بناء معالجة الاستثناءات C على ثلاث كلمات رئيسية: حاول ، التقط ، ورمي. رمي - برنامج يطرح استثناء عند ظهور مشكلة. يتم ذلك باستخدام كلمة مفتاحية رمي. catch - يلتقط برنامج استثناء مع معالج استثناء في مكان في البرنامج حيث تريد معالجة المشكلة. تشير الكلمة الأساسية catch إلى اصطياد استثناء. try - تحدد كتلة try مجموعة التعليمات البرمجية التي سيتم تنشيط استثناءات معينة لها. يتبعها كتلة صيد واحدة أو أكثر. بافتراض أن الكتلة ستثير استثناءً ، فإن الطريقة تلتقط استثناءً باستخدام مجموعة من الكلمات الأساسية try and catch. محاولة

try {
   // protected code
} catch( ExceptionName e1 ) {
   // catch block
} catch( ExceptionName e2 ) {
   // catch block
} catch( ExceptionName eN ) {
   // catch block
}

You can list down multiple catch statements to catch different type of exceptions in case your try block raises more than one exception in different situations.

Throwing Exceptions

Exceptions can be thrown anywhere within a code block using throw statement. The operand of the throw statement determines a type for the exception and can be any expression and the type of the result of the expression determines the type of exception thrown.

Following is an example of throwing an exception when dividing by zero condition occurs −

يمكن طرح استثناءات استثناءات في أي مكان داخل كتلة التعليمات البرمجية باستخدام تعليمة الرمي. يحدد معامل تعليمة الرمي نوع الاستثناء ويمكن أن يكون أي تعبير ونوع نتيجة التعبير يحدد نوع الاستثناء الذي تم طرحه. فيما يلي مثال على طرح استثناء عند حدوث القسمة على صفر -

double division(int a, int b) {
   if( b == 0 ) {
      throw "Division by zero condition!";
   }
   return (a/b);
}

Catching Exceptions

The catch block following the try block catches any exception. You can specify what type of exception you want to catch and this is determined by the exception declaration that appears in parentheses following the keyword catch.

try {
   // protected code
} catch( ExceptionName e ) {
  // code to handle ExceptionName exception
}

Above code will catch an exception of ExceptionName type. If you want to specify that a catch block should handle any type of exception that is thrown in a try block, you must put an ellipsis, ..., between the parentheses enclosing the exception declaration as follows −

سيصطاد الرمز أعلاه استثناء من نوع ExceptionName. إذا كنت تريد تحديد أن كتلة catch يجب أن تتعامل مع أي نوع من الاستثناءات التي يتم طرحها في كتلة try ، فيجب عليك وضع علامة القطع ، ... ، بين الأقواس التي تتضمن إعلان الاستثناء على النحو التالي -

try {
   // protected code
} catch(...) {
  // code to handle any exception
}

The following is an example, which throws a division by zero exception and we catch it in catch block.


#include <iostream>
using namespace std;

double division(int a, int b) {
   if( b == 0 ) {
      throw "Division by zero condition!";
   }
   return (a/b);
}

int main () {
   int x = 50;
   int y = 0;
   double z = 0;
 
   try {
      z = division(x, y);
      cout << z << endl;
   } catch (const char* msg) {
     cerr << msg << endl;
   }

   return 0;
}

Because we are raising an exception of type const char*, so while catching this exception, we have to use const char* in catch block. If we compile and run above code, this would produce the following result −

نظرًا لأننا نرفع استثناءً من النوع const char * ، لذلك أثناء اكتشاف هذا الاستثناء ، يتعين علينا استخدام const char * في كتلة catch. إذا قمنا بتجميع وتشغيل الكود أعلاه ، فسيؤدي ذلك إلى النتيجة التالية -

Division by zero condition!

C++ Standard Exceptions

C++ provides a list of standard exceptions defined in <exception> which we can use in our programs. These are arranged in a parent-child class hierarchy shown below −

يوفر C قائمة بالاستثناءات القياسية المحددة في <exception> والتي يمكننا استخدامها في برامجنا. يتم ترتيبها في تسلسل هرمي لفئة الوالدين والطفل الموضح أدناه -

C++ Exceptions Hierarchy

Here is the small description of each exception mentioned in the above hierarchy −

Sr.NoException & Description
1

std::exception

An exception and parent class of all the standard C++ exceptions.

2

std::bad_alloc

This can be thrown by new.

3

std::bad_cast

This can be thrown by dynamic_cast.

4

std::bad_exception

This is useful device to handle unexpected exceptions in a C++ program.

5

std::bad_typeid

This can be thrown by typeid.

6

std::logic_error

An exception that theoretically can be detected by reading the code.

7

std::domain_error

This is an exception thrown when a mathematically invalid domain is used.

8

std::invalid_argument

This is thrown due to invalid arguments.

9

std::length_error

This is thrown when a too big std::string is created.

10

std::out_of_range

This can be thrown by the 'at' method, for example a std::vector and std::bitset<>::operator[]().

11

std::runtime_error

An exception that theoretically cannot be detected by reading the code.

12

std::overflow_error

This is thrown if a mathematical overflow occurs.

13

std::range_error

This is occurred when you try to store a value which is out of range.

14

std::underflow_error

This is thrown if a mathematical underflow occurs.

Define New Exceptions

You can define your own exceptions by inheriting and overriding exception class functionality. Following is the example, which shows how you can use std::exception class to implement your own exception in standard way −


#include <iostream>
#include <exception>
using namespace std;

struct MyException : public exception {
   const char * what () const throw () {
      return "C++ Exception";
   }
};
 
int main() {
   try {
      throw MyException();
   } catch(MyException& e) {
      std::cout << "MyException caught" << std::endl;
      std::cout << e.what() << std::endl;
   } catch(std::exception& e) {
      //Other errors
   }
}

This would produce the following result −

MyException caught
C++ Exception

Here, what() is a public method provided by exception class and it has been overridden by all the child exception classes. This returns the cause of an exception.

هنا ، ما هي الطريقة العامة التي توفرها فئة الاستثناء وقد تم تجاوزها من قبل جميع فئات الاستثناء الفرعية. هذا ما يعيد سبب الاستثناء.


هل اعجبك الموضوع :

تعليقات